"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reduceWithContext = exports.prefixed = exports.isUnsupported = exports.isSourceUnavailable = exports.isOr = exports.isMissingDataOnly = exports.isMissingData = exports.isInvalidData = exports.isConfigError = exports.isAnd = exports.Unsupported = exports.SourceUnavailable = exports.Or = exports.MissingData = exports.InvalidData = exports.ConfigErrorTypeId = exports.And = void 0;
var internal = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/io/internal/configError"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * @since 1.0.0
 * @category symbols
 */
const ConfigErrorTypeId = internal.ConfigErrorTypeId;
/**
 * @since 1.0.0
 * @category constructors
 */
exports.ConfigErrorTypeId = ConfigErrorTypeId;
const And = internal.And;
/**
 * @since 1.0.0
 * @category constructors
 */
exports.And = And;
const Or = internal.Or;
/**
 * @since 1.0.0
 * @category constructors
 */
exports.Or = Or;
const MissingData = internal.MissingData;
/**
 * @since 1.0.0
 * @category constructors
 */
exports.MissingData = MissingData;
const InvalidData = internal.InvalidData;
/**
 * @since 1.0.0
 * @category constructors
 */
exports.InvalidData = InvalidData;
const SourceUnavailable = internal.SourceUnavailable;
/**
 * @since 1.0.0
 * @category constructors
 */
exports.SourceUnavailable = SourceUnavailable;
const Unsupported = internal.Unsupported;
/**
 * Returns `true` if the specified value is a `ConfigError`, `false` otherwise.
 *
 * @since 1.0.0
 * @category refinements
 */
exports.Unsupported = Unsupported;
const isConfigError = internal.isConfigError;
/**
 * Returns `true` if the specified `ConfigError` is an `And`, `false` otherwise.
 *
 * @since 1.0.0
 * @category refinements
 */
exports.isConfigError = isConfigError;
const isAnd = internal.isAnd;
/**
 * Returns `true` if the specified `ConfigError` is an `Or`, `false` otherwise.
 *
 * @since 1.0.0
 * @category refinements
 */
exports.isAnd = isAnd;
const isOr = internal.isOr;
/**
 * Returns `true` if the specified `ConfigError` is an `InvalidData`, `false`
 * otherwise.
 *
 * @since 1.0.0
 * @category refinements
 */
exports.isOr = isOr;
const isInvalidData = internal.isInvalidData;
/**
 * Returns `true` if the specified `ConfigError` is an `MissingData`, `false`
 * otherwise.
 *
 * @since 1.0.0
 * @category refinements
 */
exports.isInvalidData = isInvalidData;
const isMissingData = internal.isMissingData;
/**
 * Returns `true` if the specified `ConfigError` contains only `MissingData` errors, `false` otherwise.
 *
 * @since 1.0.0
 * @categer getters
 */
exports.isMissingData = isMissingData;
const isMissingDataOnly = internal.isMissingDataOnly;
/**
 * Returns `true` if the specified `ConfigError` is a `SourceUnavailable`,
 * `false` otherwise.
 *
 * @since 1.0.0
 * @category refinements
 */
exports.isMissingDataOnly = isMissingDataOnly;
const isSourceUnavailable = internal.isSourceUnavailable;
/**
 * Returns `true` if the specified `ConfigError` is an `Unsupported`, `false`
 * otherwise.
 *
 * @since 1.0.0
 * @category refinements
 */
exports.isSourceUnavailable = isSourceUnavailable;
const isUnsupported = internal.isUnsupported;
/**
 * @since 1.0.0
 * @category utils
 */
exports.isUnsupported = isUnsupported;
const prefixed = internal.prefixed;
/**
 * @since 1.0.0
 * @category folding
 */
exports.prefixed = prefixed;
const reduceWithContext = internal.reduceWithContext;
exports.reduceWithContext = reduceWithContext;
//# sourceMappingURL=ConfigError.js.map