import * as fiberRuntime from "@effect/io/internal/fiberRuntime";
import * as circular from "@effect/io/internal/layer/circular";
import * as internal from "@effect/io/internal/logger";
import * as internalCircular from "@effect/io/internal/logger-circular";
/**
 * @since 1.0.0
 * @category symbols
 */
export const LoggerTypeId = internal.LoggerTypeId;
/**
 * @category constructors
 * @since 1.0.0
 */
export const make = internal.makeLogger;
/**
 * @since 1.0.0
 * @category context
 */
export const add = circular.addLogger;
/**
 * @since 1.0.0
 * @category context
 */
export const addEffect = circular.addLoggerEffect;
/**
 * @since 1.0.0
 * @category context
 */
export const addScoped = circular.addLoggerScoped;
/**
 * @since 1.0.0
 * @category mapping
 */
export const mapInput = internal.mapInput;
/**
 * Returns a version of this logger that only logs messages when the log level
 * satisfies the specified predicate.
 *
 * @since 1.0.0
 * @category filtering
 */
export const filterLogLevel = internal.filterLogLevel;
/**
 * @since 1.0.0
 * @category mapping
 */
export const map = internal.map;
/**
 * A logger that does nothing in response to logging events.
 *
 * @since 1.0.0
 * @category constructors
 */
export const none = internal.none;
/**
 * @since 1.0.0
 * @category context
 */
export const remove = circular.removeLogger;
/**
 * @since 1.0.0
 * @category context
 */
export const replace = circular.replaceLogger;
/**
 * @since 1.0.0
 * @category context
 */
export const replaceEffect = circular.replaceLoggerEffect;
/**
 * @since 1.0.0
 * @category context
 */
export const replaceScoped = circular.replaceLoggerScoped;
/**
 * @since 1.0.0
 * @category constructors
 */
export const simple = internal.simple;
/**
 * @since 1.0.0
 * @category constructors
 */
export const succeed = internal.succeed;
/**
 * @since 1.0.0
 * @category constructors
 */
export const sync = internal.sync;
/**
 * @since 1.0.0
 * @category constructors
 */
export const test = internalCircular.test;
/**
 * @since 1.0.0
 * @category context
 */
export const withMinimumLogLevel = circular.withMinimumLogLevel;
/**
 * Combines this logger with the specified logger to produce a new logger that
 * logs to both this logger and that logger.
 *
 * @since 1.0.0
 * @category zipping
 */
export const zip = internal.zip;
/**
 * @since 1.0.0
 * @category zipping
 */
export const zipLeft = internal.zipLeft;
/**
 * @since 1.0.0
 * @category zipping
 */
export const zipRight = internal.zipRight;
/**
 * @since 1.0.0
 * @category constructors
 */
export const defaultLogger = fiberRuntime.defaultLogger;
/**
 * @since 1.0.0
 * @category constructors
 */
export const logfmtLogger = internal.logfmtLogger;
/**
 * @since 1.0.0
 * @category constructors
 */
export const stringLogger = internal.stringLogger;
/**
 * @since 1.0.0
 * @category constructors
 */
export const tracerLogger = fiberRuntime.tracerLogger;
/**
 * @since 1.0.0
 * @category constructors
 */
export const logFmt = /*#__PURE__*/replace(fiberRuntime.defaultLogger, fiberRuntime.logFmtLogger);
/**
 * @since 1.0.0
 * @category context
 */
export const minimumLogLevel = circular.minimumLogLevel;
//# sourceMappingURL=Logger.mjs.map