/**
 * Bun currently has a bug where `setTimeout` doesn't behave correctly with a 0ms delay.
 *
 * @see https://github.com/oven-sh/bun/issues/3333
 */
/** @internal */
const isBun = typeof process === "undefined" ? false : !!process?.isBun;
/** @internal */
export const clear = isBun ? clearInterval : clearTimeout;
/** @internal */
export const set = isBun ? (fn, ms) => {
  const id = setInterval(() => {
    fn();
    clearInterval(id);
  }, ms);
  return id;
} : setTimeout;
//# sourceMappingURL=timeout.mjs.map